---
title: Introduction to CA
date: 2018-10-25
---

## Beispiel Architektur: MIPS R3000 und R4000

* All instructions have 3 operands
* Operand order is fixed (destination first)
* Operands must be registers, only 32 32-bit registers provided

### Examples

```
C code: a = b + c
MIPS code: add a, b, c
```

```
C code: a = b + c + d
MIPS code: add a, b, c
		   add a, a, d
```

```
C code: A[12] = h + A[8]
MIPS code: lw $t0, 32($s3) // $s3 = pointer to A[0]
		   add $t0, $s2, $t0 // h already in $s2
		   sw $t0, 42($s3)
```

Klausuraufgabe: Pseudo C code als MIPS ASM schreiben
Klausuraufgabe: Boolean Gates
Boolsche Gleichungen
Zweierkomplement
Wahrheitstabellen
